<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (129)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="textdecoder-and-textencoder">TextDecoder and TextEncoder</h1>
    <p>
      What if the binary data is actually a string? For instance, we received a
      file with textual data.
    </p>
    <p>
      The build-in
      <a href="https://encoding.spec.whatwg.org/#interface-textdecoder"
        >TextDecoder</a
      >
      object allows to read the value into an actual JavaScript string, given
      the buffer and the encoding.
    </p>
    <p>We first need to create it:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">let</span> decoder <span class="op">=</span> <span class="kw">new</span> <span class="at">TextDecoder</span>([label]<span class="op">,</span> [options])<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        <strong><code>label</code></strong> – the encoding,
        <code>utf-8</code> by default, but <code>big5</code>,
        <code>windows-1251</code> and many other are also supported.
      </li>
      <li>
        <strong><code>options</code></strong> – optional object:
        <ul>
          <li>
            <strong><code>fatal</code></strong> – boolean, if
            <code>true</code> then throw an exception for invalid
            (non-decodable) characters, otherwise (default) replace them with
            character <code>\uFFFD</code>.
          </li>
          <li>
            <strong><code>ignoreBOM</code></strong> – boolean, if
            <code>true</code> then ignore BOM (an optional byte-order Unicode
            mark), rarely needed.
          </li>
        </ul>
      </li>
    </ul>
    <p>…And then decode:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> str <span class="op">=</span> <span class="va">decoder</span>.<span class="at">decode</span>([input]<span class="op">,</span> [options])<span class="op">;</span></a></code></pre>
    </div>
    <ul>
      <li>
        <strong><code>input</code></strong> – <code>BufferSource</code> to
        decode.
      </li>
      <li>
        <strong><code>options</code></strong> – optional object:
        <ul>
          <li>
            <strong><code>stream</code></strong> – true for decoding streams,
            when <code>decoder</code> is called repeatedly with incoming chunks
            of data. In that case a multi-byte character may occasionally split
            between chunks. This options tells <code>TextDecoder</code> to
            memorize “unfinished” characters and decode them when the next chunk
            comes.
          </li>
        </ul>
      </li>
    </ul>
    <p>For instance:</p>
    <p>```js run let uint8Array = new Uint8Array([72, 101, 108, 108, 111]);</p>
    <p>alert(new TextDecoder().decode(uint8Array)); // Hello ```</p>
    <p>
      ```js run let uint8Array = new Uint8Array([228, 189, 160, 229, 165, 189]);
    </p>
    <p>alert(new TextDecoder().decode(uint8Array)); // 你好 ```</p>
    <p>
      We can decode a part of the buffer by creating a subarray view for it:
    </p>
    <p>
      ```js run let uint8Array = new Uint8Array([0, 72, 101, 108, 108, 111, 0]);
    </p>
    <p>
      // the string is in the middle // create a new view over it, without
      copying anything let binaryString = uint8Array.subarray(1, -1);
    </p>
    <p>alert(new TextDecoder().decode(binaryString)); // Hello ```</p>
    <h2 id="textencoder">TextEncoder</h2>
    <p>
      <a href="https://encoding.spec.whatwg.org/#interface-textencoder"
        >TextEncoder</a
      >
      does the reverse thing – converts a string into bytes.
    </p>
    <p>The syntax is:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> encoder <span class="op">=</span> <span class="kw">new</span> <span class="at">TextEncoder</span>()<span class="op">;</span></a></code></pre>
    </div>
    <p>The only encoding it supports is “utf-8”.</p>
    <p>It has two methods:</p>
    <ul>
      <li>
        <strong><code>encode(str)</code></strong> – returns
        <code>Uint8Array</code> from a string.
      </li>
      <li>
        <strong><code>encodeInto(str, destination)</code></strong> – encodes
        <code>str</code> into <code>destination</code> that must be
        <code>Uint8Array</code>.
      </li>
    </ul>
    <p>```js run let encoder = new TextEncoder();</p>
    <p>
      let uint8Array = encoder.encode(“Hello”); alert(uint8Array); //
      72,101,108,108,111 ```
    </p>
  </body>
</html>
